//********************************************************************
PROGRAM DataProviderDemo;
//********************************************************************
USES
  SysUtils,
  Classes,
  TypInfo,
  dglRTTI,
  dglDataProvider,
  TestUnit;
//********************************************************************
Procedure TestByName;
Var
   MyObject: TTestObject1;
   MyRTTI: TRTTI_Handler;
   FloatValue: Double;
   StringValue: String;
Begin
   //PreSettings of RTTI-handler
   MyRTTI:= TRTTI_Handler.Create;       // Create RTTI-handler
   MyRTTI.DataExchange:= dxString;      // agree upon exchanging strings

   MyObject:= TTestObject1.Create;      // Create object
   MyRTTI.Client:= MyObject;            // Plug object into RTTI-handler

   MyRTTI.StrValByName['Name']:= 'Rudi';           // Input values
   MyRTTI.StrValByName['NumberInt']:= '24';        // into object using
   MyRTTI.StrValByName['NumberFloat']:= '123,45';  // RTTI-handler

   StringValue:= MyRTTI.StrValByName['NumberFloat'];

   MyObject.Free; // Forces CRASH

   MyRTTI.DataExchange:= dxBinary;  // agree upon exchanging binaries
   FloatValue:= MyRTTI.ValueByName['NumberFloat'].VFloat;  // Output value

   //MyObject.Free;
   MyRTTI.Free;
End;
//********************************************************************
Procedure SaveTest;
Var
   LDataProvider: TCSV_DataProvider;
   MyObject: TTestObject2;
Begin
   MyObject:= TTestObject2.Create;

   With MyObject.AObject Do Begin
      Name:= 'Rudi'; NumberInt:= 24; NumberFloat:= 123.45;
   End;
   With MyObject.BObject Do Begin
      Name:= 'Karin'; NumberInt:= 112; NumberFloat:= 678.91;
   End;

   LDataProvider:= TCSV_DataProvider.Create('FILE_RTTI', faSave);
   LDataProvider.SaveClient(MyObject);
   LDataProvider.Free;

   MyObject.Free;
End;
//********************************************************************
Procedure LoadTest;
Var
   LDataProvider: TCSV_DataProvider;
   MyObject: TTestObject2;
   Lines: TStringList;
Begin
   LDataProvider:= TCSV_DataProvider.Create('FILE_RTTI', faLoad);
   With LDataProvider Do MyObject:= TTestObject2(LoadClient);
   LDataProvider.Free;

   Lines:= TStringList.Create;
   With MyObject.AObject,Lines Do Begin
      Add(Name);
      Add(IntToStr(NumberInt));
      Add(FloatToStr(NumberFloat));
   End;
   With MyObject.BObject,Lines Do Begin
      Add(Name);
      Add(IntToStr(NumberInt));
      Add(FloatToStr(NumberFloat));
   End;
   Lines.SaveToFile('LOADED_CONTENT.Txt');
   Lines.Free;

   MyObject.Free;
End;
//********************************************************************
// MAINPROGRAM
Begin
   TestByName; // tested die Exceptions
   SaveTest;
   LoadTest;
End.
