//********************************************************************
UNIT TestUnit;
//********************************************************************
INTERFACE

USES
   Classes, dglRTTI;
//********************************************************************
TYPE

{$M+}

   TTestObject1 = Class(TPersistent)
   Private
      fName: String;
      fNumberInt: Integer;
      fNumberFloat: Double;
   Published
      Property Name: String Read fName Write fName;
      Property NumberInt: Integer Read fNumberInt Write fNumberInt;
      Property NumberFloat: Double Read fNumberFloat Write fNumberFloat;
   End;

   TTestObject2 = Class(TPersistent)
   Private
      fAObject: TTestObject1;
      fBObject: TTestObject1;
   Public
      Constructor Create; Reintroduce;
      Destructor Destroy; Override;
   Published
      Property AObject: TTestObject1 Read fAObject Write fAObject;
      Property BObject: TTestObject1 Read fBObject Write fBObject;
   End;

{$M+}

//********************************************************************
IMPLEMENTATION
//********************************************************************
Constructor TTestObject2.Create;
Begin
   Inherited Create;
   fAObject:= TTestObject1.Create;
   fBObject:= TTestObject1.Create;
End;
//********************************************************************
Destructor TTestObject2.Destroy;
Begin
   fBObject.Free;
   fAObject.Free;
   Inherited Destroy;
End;
//********************************************************************
//********************************************************************
Initialization
  // Register loadable classes
  RegisterClass(TTestObject1);
  RegisterClass(TTestObject2);
//********************************************************************
End.
